<?php
/*
Plugin Name: Relative Links
Version: 1.0
Plugin URI: http://mathibus.com/
Description: When activated, this plugin filters WordPress' output, removing redundant stuff from on-site links.
Author: Mathias Bynens
Author URI: http://mathibus.com/
*/

function get_root($url) { // not everybody has his blog running from the root
	while(substr_count($url, '/') > 2) { // all we need is the :// from the protocol
		$array = explode('/', $url);
		array_pop($array);
		$url = implode('/', $array);
	}
	return $url;
}

function relative_links($str) {
	$url = get_root(get_settings('siteurl'));
/*
	Uncomment the following line, and replace "http://mathibus.com" with
	your untrailingslashed root URI to speed things up a little.
	Don't forget to remove the above line saying $url = get_root(get_settings('siteurl'));
	if you do so.
*/
//	$url = 'http://mathibus.com';
	$str = str_replace("'" . $url ."/", "'/", $str);	// <a href="http://yoursite.com/whatever/">
	$str = str_replace('"' . $url . '/', '"/', $str);	// <a href='http://yoursite.com/whatever/'>
	$str = str_replace('"' . $url . '"', '"/"', $str);	// <a href="http://yoursite.com">
	$str = str_replace("'" . $url . "'", "'/'", $str);	// <a href='http://yoursite.com">
	return $str;
}

/*
	I'm afraid we'll have to use ob_start(), as
	- add_filter('the_permalink', 'relative_links_uri'); (special URI-only function)
	- add_filter('post_link', 'relative_links_uri');
	et al would affect syndication feeds as well
*/

if(!strstr($_SERVER['REQUEST_URI'], $url . '/wp-admin')) ob_start('relative_links'); // do not filter in admin section

?>